'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _abstractSeries = require('./abstract-series');

var _abstractSeries2 = _interopRequireDefault(_abstractSeries);

var _reactUtils = require('../../utils/react-utils');

var _theme = require('../../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Uber Technologies, Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var AreaSeries = function (_AbstractSeries) {
  _inherits(AreaSeries, _AbstractSeries);

  _createClass(AreaSeries, null, [{
    key: 'isDomainAdjustmentNeeded',
    value: function isDomainAdjustmentNeeded() {
      return false;
    }
  }, {
    key: 'displayName',
    get: function get() {
      return 'AreaSeries';
    }
  }]);

  function AreaSeries(props) {
    _classCallCheck(this, AreaSeries);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(AreaSeries).call(this, props));

    _this._mouseOut = _this._mouseOut.bind(_this);
    _this._mouseOver = _this._mouseOver.bind(_this);
    return _this;
  }

  _createClass(AreaSeries, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._updateSeries();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this._updateSeries();
    }
  }, {
    key: '_mouseOver',
    value: function _mouseOver(d) {
      var _props = this.props;
      var onValueMouseOver = _props.onValueMouseOver;
      var onSeriesMouseOver = _props.onSeriesMouseOver;

      if (onValueMouseOver) {
        onValueMouseOver(d, { event: _d2.default.event });
      }
      if (onSeriesMouseOver) {
        onSeriesMouseOver({ event: _d2.default.event });
      }
    }
  }, {
    key: '_mouseOut',
    value: function _mouseOut(d) {
      var _props2 = this.props;
      var onValueMouseOut = _props2.onValueMouseOut;
      var onSeriesMouseOut = _props2.onSeriesMouseOut;

      if (onValueMouseOut) {
        onValueMouseOut(d, { event: _d2.default.event });
      }
      if (onSeriesMouseOut) {
        onSeriesMouseOut({ event: _d2.default.event });
      }
    }
  }, {
    key: '_updateSeries',
    value: function _updateSeries() {
      var lineElement = (0, _reactUtils.getDOMNode)(this.refs.line);
      var _props3 = this.props;
      var data = _props3.data;
      var innerHeight = _props3.innerHeight;

      if (!data) {
        return;
      }

      var x = this._getAttributeFunctor('x');
      var y = this._getAttributeFunctor('y');
      var fill = this._getAttributeValue('fill') || this._getAttributeValue('color');

      var stroke = this._getAttributeValue('stroke') || this._getAttributeValue('color');

      var line = _d2.default.svg.area().x(x).y0(innerHeight).y1(y);
      var opacity = this._getAttributeValue('opacity') || _theme.DEFAULT_OPACITY;
      var d = line(data);

      var path = _d2.default.select(lineElement).on('mouseover', this._onMouseOver).on('mouseout', this._onMouseOut);

      this._applyTransition(path).attr('d', d).style('stroke', stroke).style('fill', fill).style('opacity', opacity);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props;
      var data = _props4.data;
      var marginLeft = _props4.marginLeft;
      var marginTop = _props4.marginTop;

      if (!data) {
        return null;
      }
      return _react2.default.createElement('path', {
        ref: 'line',
        style: { opacity: 0 },
        className: 'rv-xy-plot__series rv-xy-plot__series--area',
        transform: 'translate(' + marginLeft + ',' + marginTop + ')' });
    }
  }]);

  return AreaSeries;
}(_abstractSeries2.default);

exports.default = AreaSeries;